var _ = require("lodash");
var http = require('http');
var fs = require('fs');
var url = require('url');
var restler = require('restler');

function uploadFile(uploadUrl,params,fileParams,ondata,onerror){
   // console.log("upload %s %s",JSON.stringify(params),JSON.stringify(fileParams));
    _.forEach(fileParams,function(val,key){
        var stats = fs.statSync(val);
        params[key] = restler.file(val,null,stats.size, null,null);
    });
//    console.log(params);
    restler.post(uploadUrl, {
        multipart: true,
        data: params
    }).on('success', function(data) {
        ondata(data);
    }).on('error', function(err, response) {
        onerror && onerror("error",err,response);
    }).on('fail', function(err, response) {
        onerror && onerror("fail",err,response);
    }).on('timeout', function(err, response) {
        onerror && onerror("timeout",err,response);
    });

}

function doPost(url,params,ondata,onerror){
    restler.post(url, {
        data: params
    }).on('success', function(data) {
            ondata(data);
    }).on('error', function(err, response) {
            onerror && onerror("error",err,response);
    }).on('fail', function(err, response) {
            onerror && onerror("fail",err,response);
    }).on('timeout', function(err, response) {
            onerror && onerror("timeout",err,response);
    });
}

module.exports = {
    uploadFile:uploadFile,
    doPost:doPost
};